library(lpSolve)
library(MASS)

AF_num<-1			#1: Random, 2: US, 3: DRBO, 4: DRPTR, 5: CCBO, 6: Proposed, 7: MVA 





######################## parameter ##############################
sampling_num<-1000
rounds<-100
repeat_num<-100
grid_num<-50


cost_sigmaf<-10^4
cost_L<-0.1
cost_sigman<-10^(-3)
cost_beta<-2

sigmaf<-10^5
L<- 0.1
sigman<- 10^(-3)
beta<-3

h<- 100
alpha<-0.69


gamma<-10^(-1)
accuracy_para<-10^(-12)
epsilon_t<-0.15
ref_p<- (numeric(grid_num)+1)/grid_num

L1<- 0.01
U1<- 0.5
L2<- 0.01
U2<- 0.5

#############function f ###############

cost_function1_mat<-t(as.matrix(read.table("risk2.txt"))*(-1))

#############function g ###############

true_function_mat<-  t(as.matrix(read.table("risk1.txt"))*(-1))





stn<-function(x){
(2*pi)^(-1/2)*exp(-x^2/2)
}






x<- seq(L1,U1,length=grid_num)
w<- seq(L2,U2,length=grid_num)

true_function_mat_above<-  (true_function_mat>h)*1

ref_p_above<-as.vector(true_function_mat_above%*%ref_p)


f1<- (numeric(grid_num)+1)%x%c(1,-1)
D<-diag(2*grid_num)
f2<-numeric(2*grid_num)+1
f3<- diag(grid_num)%x% t(c(1,-1))

f.con <- rbind(f1,D,f2,f3,f3)
f.dir <- c("==", 
">=",">=",">=",">=",">=",">=",">=",">=",">=",">=",
">=",">=",">=",">=",">=",">=",">=",">=",">=",">=",
">=",">=",">=",">=",">=",">=",">=",">=",">=",">=",
">=",">=",">=",">=",">=",">=",">=",">=",">=",">=",
">=",">=",">=",">=",">=",">=",">=",">=",">=",">=",
">=",">=",">=",">=",">=",">=",">=",">=",">=",">=",
">=",">=",">=",">=",">=",">=",">=",">=",">=",">=",
">=",">=",">=",">=",">=",">=",">=",">=",">=",">=",
">=",">=",">=",">=",">=",">=",">=",">=",">=",">=",
">=",">=",">=",">=",">=",">=",">=",">=",">=",">=",
"<=",
"<=","<=","<=","<=","<=","<=","<=","<=","<=","<=",
"<=","<=","<=","<=","<=","<=","<=","<=","<=","<=",
"<=","<=","<=","<=","<=","<=","<=","<=","<=","<=",
"<=","<=","<=","<=","<=","<=","<=","<=","<=","<=",
"<=","<=","<=","<=","<=","<=","<=","<=","<=","<=",
">=",">=",">=",">=",">=",">=",">=",">=",">=",">=",
">=",">=",">=",">=",">=",">=",">=",">=",">=",">=",
">=",">=",">=",">=",">=",">=",">=",">=",">=",">=",
">=",">=",">=",">=",">=",">=",">=",">=",">=",">=",
">=",">=",">=",">=",">=",">=",">=",">=",">=",">="
)
f.rhs <- c(numeric((2*grid_num)+1),epsilon_t,(numeric(grid_num)+1-ref_p),(numeric(grid_num)-ref_p))
f.rhs_c <- c(numeric((2*grid_num)+1),epsilon_t,(numeric(grid_num)+1-ref_p),(numeric(grid_num)-ref_p))


result<-numeric(grid_num)
for(i in 1:grid_num)
{
f.obj <-true_function_mat_above[i,]%x%c(1,-1)


resu<-lp ("min", f.obj, f.con, f.dir, f.rhs)
result[i]<- resu$objval
}

true_dist_ptr<-result+ref_p_above




compute_kernel<- function(x,y)
{
sqrt(sigmaf)*exp(-(x-y)^2/L)
}



compute_cost_kernel<- function(x1,y1,x2,y2)
{
cost_sigmaf*exp(-((x1-x2)^2+(y1-y2)^2)/cost_L)
}


compute_straddle<-function(x)
{
  min(x[2]-alpha,alpha-x[1])
}




TRUE_P<-  c(1:length(x))[true_dist_ptr>alpha]
TRUE_N<-  c(1:length(x))[true_dist_ptr<=alpha]


compute_pre_P<-function(x)
{
a<-0
	if(length(x)<0.1)
	{
	a<-0
	} else {
	a<-     length(intersect(x,TRUE_P))/length(x)
	}
a
}


compute_rec_P<-function(x)
{
   length(intersect(x,TRUE_P))/length(TRUE_P)
}



compute_pre_N<-function(x)
{
a<-0
	if(length(x)<0.1)
	{
	a<-0
	} else {
	a<-     length(intersect(x,TRUE_N))/length(x)
	}
a
}


compute_rec_N<-function(x)
{
   length(intersect(x,TRUE_N))/length(TRUE_N)
}

compute_accuracy<-function(x,y)
{
(length(intersect(x,TRUE_P) )+length(intersect(y,TRUE_N) ))/(length(TRUE_P)+length(TRUE_N))
}


ALLinput<-   cbind(x%x%(w*0+1),(x*0+1)%x%w)





resultc<-numeric(grid_num)
for(i in 1:grid_num)
{
f.obj <-cost_function1_mat[i,]%x%c(1,-1)


resu<-lp ("min", f.obj, f.con, f.dir, f.rhs_c)
resultc[i]<- resu$objval
}

cF1<-resultc+as.vector(cost_function1_mat%*%ref_p)






max_cF1<- max(cF1[true_dist_ptr>=alpha])
min_cF1<- min(cF1) 


UG_mat<-  matrix(numeric(repeat_num*rounds),repeat_num,rounds)

compute_estimated_prob<-function(x)
{
l<-x[1]
u<-x[2]
	if(l>=alpha)
	{
	p<-1
	} 
	if(u<alpha)
	{
	p<-0
	}
	if( (u>=alpha) && (l<alpha))
	{
	p<- (u-alpha)/(u-l)
	}
p	
}






all_input<-ALLinput
all_input_x<- all_input[,1]
all_input_y<- all_input[,2]

compute_kernel2<- function(x1,y1,x2,y2)
{
sigmaf*exp(-((x1-x2)^2+(y1-y2)^2)/L)
}



compute_MILE<-function(t)
{

new_input<- all_input[t,]
new_cov<- compute_kernel2(all_input_x,all_input_y,new_input[1],new_input[2])-Kvec_invK_tKvec[,t]
new_sqrt<- sqrt(abs(post_var-(new_cov)^2/(post_var[t]+sigman)))
new_coef<-new_cov/sqrt(post_var[t]+sigman)
new_coef[new_coef==0]<-10^(-30)
new_coef<- matrix(new_coef,grid_num,grid_num)

inter<- matrix((h+beta*new_sqrt - post_mean),grid_num,grid_num)/new_coef

result_b<-numeric(grid_num)
for(j in 1:grid_num)
{
	if(dist_ptr_lcb[j]>=alpha)
	{
	result_b[j]<-1
	} else {
	a<-inter[,j]
	b<-new_coef[,j]

	b2<- b[order(a)]
	a2<-sort(a)
	aminus<- c(-Inf,a2) 
	aplus<- c(a2,Inf)
	pro<- pnorm(aplus)-pnorm(aminus)
	result_b2<- numeric(grid_num+1)
	cupro<-pnorm(aplus)
	minnum<- min(c(1:(grid_num+1))[cupro>0.005])
	maxnum<- min(c(1:(grid_num+1))[cupro>0.995])

	c<- a2[1]-0.01
	c1<-  ((post_mean[((j-1)*grid_num+1):(j*grid_num)]+c*b-beta*new_sqrt[((j-1)*grid_num+1):(j*grid_num)])>h)*1
	sumc1refp<-sum(c1*ref_p)
		if(sumc1refp<=alpha)
		{
		result_b2[1]<- -1
		} else {
			if(1<minnum||1>maxnum)
			{
			result_b2[1]<- -1
			} else {
			f.obj <-c1%x%c(1,-1)


			resu<-lp ("min", f.obj, f.con, f.dir, f.rhs)
			result_b2[1]<- resu$objval+sumc1refp

			}
		}


	for(k in 2:grid_num)
	{
	c<- (a2[k]+a2[(k-1)])/2
	c1<-  ((post_mean[((j-1)*grid_num+1):(j*grid_num)]+c*b-beta*new_sqrt[((j-1)*grid_num+1):(j*grid_num)])>h)*1
	sumc1refp<-sum(c1*ref_p)
		if(sumc1refp<=alpha)
		{
		result_b2[k]<- -1
		} else {
		if(k<minnum||k>maxnum)
		{
		result_b2[k]<- -1
		} else {
		f.obj <-c1%x%c(1,-1)


		resu<-lp ("min", f.obj, f.con, f.dir, f.rhs)
		result_b2[k]<- resu$objval+sumc1refp

		}
	}

 
	}
c<- a2[grid_num]+0.01
c1<-  ((post_mean[((j-1)*grid_num+1):(j*grid_num)]+c*b-beta*new_sqrt[((j-1)*grid_num+1):(j*grid_num)])>h)*1

sumc1refp<-sum(c1*ref_p)
if(sumc1refp<=alpha)
{
result_b2[(grid_num+1)]<- -1
} else {
	if((grid_num+1)<minnum||(grid_num+1)>maxnum)
	{
	result_b2[(grid_num+1)]<- -1
	} else {
	f.obj <-c1%x%c(1,-1)


	resu<-lp ("min", f.obj, f.con, f.dir, f.rhs)
	result_b2[(grid_num+1)]<- resu$objval+sumc1refp

	}
}


result_b[j]<- sum((result_b2>alpha)*pro)
}
}
sum(result_b)
}


compute_fMILE<-function(t)
{

new_input<- all_input[t,]
new_cov<- compute_kernel2(all_input_x,all_input_y,new_input[1],new_input[2])-Kvec_invK_tKvec[,t]
new_sqrt<- sqrt(abs(post_var-(new_cov)^2/(post_var[t]+sigman)))
sum(pnorm(sqrt((post_var[t]+sigman))/abs(new_cov)*(post_mean-beta*new_sqrt-h))*(((dist_ptr_lcb<alpha)*(dist_ptr_ucb>alpha))%x%(numeric(grid_num)+1)))
}

compute_cost_kernel_w<- function(y1,y2)
{
cost_sigmaf*exp(-((y1-y2)^2)/cost_L)
}

compute_kernel_w<- function(x,y)
{
sigmaf*exp(-(x-y)^2/L)
}

prior_cov_cost<-outer(w,w,compute_cost_kernel_w)
prior_cov<-outer(w,w,compute_kernel_w)

compute_EI<-function(mu,var,best)
{
Z<- (mu-best)/sqrt(var)
sqrt(var)*Z*pnorm(Z)+sqrt(var)*stn(Z)
}

selected_X_mat<- matrix(numeric(repeat_num*rounds),repeat_num,rounds)

for(ww in 1:repeat_num)
{
set.seed(ww)

new_x_num<- sample( c(1:length(x)),1)
new_w_num<- sample( c(1:length(w)),1)

newx<-  x[new_x_num]
neww<- w[new_w_num]

newy<- true_function_mat[new_x_num,new_w_num]+rnorm(1,0,sqrt(sigman))
newy2<- cost_function1_mat[new_x_num,new_w_num]+rnorm(1,0,sqrt(cost_sigman))



C_X<-c()
C_W<-c()
C_Y<-c()
C_Y2<-c()

C_X_num<-c()
C_W_num<-c()

mean_cost_kerV<-matrix(numeric(grid_num*rounds),grid_num,rounds)


	for(www in 1: rounds)
	{
	selected_X_mat[ww,www]<- (true_dist_ptr[new_x_num]>alpha)*1

	C_X<-c(C_X,newx)
	C_W<-c(C_W,neww)
	C_Y<-c(C_Y,newy)
	C_Y2<-c(C_Y2,newy2)

	C_X_num<-c(C_X_num,new_x_num)
	C_W_num<-c(C_W_num,new_w_num)

	one_vec_trial<- numeric(www)+1
	one_vec_total_num<- ALLinput[,1]*0+1
	K<-outer(C_X,C_X,compute_kernel)*outer(C_W,C_W,compute_kernel)

	cost_K<-  matrix(compute_cost_kernel(one_vec_trial%x%C_X,one_vec_trial%x%C_W,C_X%x%one_vec_trial,C_W%x%one_vec_trial),www,www)

	C<- K+ sigman*diag(www)
	cost_C<- cost_K+	cost_sigman*diag(www)


	invC<- solve(C)
	cost_invC<- solve(cost_C)


	kerv1<- outer(x,C_X,compute_kernel)
	kerv2<- outer(w,C_W,compute_kernel)
	kerV<- kerv1%x%(w*0+1)*(x*0+1)%x%kerv2

	if(AF_num==4)
	{
	Kvec_invK_tKvec<- kerV%*%invC%*%t(kerV)
	}

	cost_kerV<-   t(matrix(compute_cost_kernel(ALLinput[,1]%x%one_vec_trial,ALLinput[,2]%x%one_vec_trial,one_vec_total_num%x%C_X,one_vec_total_num%x%C_W),www,length(one_vec_total_num)))

	post_mean<-  as.vector(kerV%*%invC%*%C_Y)
	post_var<- abs(sigmaf-rowSums((kerV%*%invC)*kerV))

	cost_post_mean<-  as.vector(cost_kerV%*%cost_invC%*%C_Y2)
	cost_post_var<- abs(cost_sigmaf-rowSums((cost_kerV%*%cost_invC)*cost_kerV))


	
	ucb<- post_mean+beta*sqrt(post_var)
	lcb<- post_mean-beta*sqrt(post_var)

	
	cost_ucb<- cost_post_mean+cost_beta*sqrt(cost_post_var)
	cost_lcb<- cost_post_mean-cost_beta*sqrt(cost_post_var)


	ucb_mat<- t(matrix(ucb,grid_num,grid_num))
	lcb_mat<- t(matrix(lcb,grid_num,grid_num))

	ucb_mat_above<- (ucb_mat>h)*1
	lcb_mat_above<- (lcb_mat>h)*1

	result_ucb<-numeric(grid_num)
	for(i in 1:grid_num)
	{
	f.obj <-ucb_mat_above[i,]%x%c(1,-1)


	resu<-lp ("min", f.obj, f.con, f.dir, f.rhs)
	result_ucb[i]<- resu$objval
	}

	dist_ptr_ucb<-result_ucb+as.vector(ucb_mat_above%*%ref_p)

	result_lcb<-numeric(grid_num)
	for(i in 1:grid_num)
	{
	f.obj <-lcb_mat_above[i,]%x%c(1,-1)


	resu<-lp ("min", f.obj, f.con, f.dir, f.rhs)
	result_lcb[i]<- resu$objval
	}

	dist_ptr_lcb<-result_lcb+as.vector(lcb_mat_above%*%ref_p)



resultc_ucb<-numeric(grid_num)
cost_ucb_mat<- t(matrix(cost_ucb,grid_num,grid_num))
	for(i in 1:grid_num)
	{
	f.obj <-cost_ucb_mat[i,]%x%c(1,-1)


	resu<-lp ("min", f.obj, f.con, f.dir, f.rhs_c)
	resultc_ucb[i]<- resu$objval
	}
cF1_ucb<- resultc_ucb+colSums(matrix(cost_ucb,grid_num,grid_num)*ref_p)


resultc_lcb<-numeric(grid_num)
cost_lcb_mat<- t(matrix(cost_lcb,grid_num,grid_num))
	for(i in 1:grid_num)
	{
	f.obj <-cost_lcb_mat[i,]%x%c(1,-1)


	resu<-lp ("min", f.obj, f.con, f.dir, f.rhs_c)
	resultc_lcb[i]<- resu$objval
	}
cF1_lcb<- resultc_lcb+colSums(matrix(cost_lcb,grid_num,grid_num)*ref_p)







st<-apply( cbind(dist_ptr_lcb,dist_ptr_ucb),1,compute_straddle)	
EST_P<-   c(1:length(x))[dist_ptr_lcb>(alpha-accuracy_para)]
EST_N<-   c(1:length(x))[dist_ptr_ucb<(alpha+accuracy_para)]






if(length(EST_P)>0)
{
h1h<- numeric(grid_num)
h1h[EST_P]<-1

est_c1<-cF1_lcb*h1h-(1-h1h)*10^10
est_c1_num<- order(est_c1,decreasing=T)[1]
	if(true_dist_ptr[est_c1_num]>=alpha)
	{
	UG_mat[ww,www]<- max_cF1-cF1[est_c1_num]
	} else {
	UG_mat[ww,www]<-max_cF1-min_cF1

	}




} else {
UG_mat[ww,www]<-max_cF1-min_cF1


}



######################## Select next x and w ############################### 
if(AF_num==1)
{
	new_x_num<- sample( c(1:length(x)),1)
	new_w_num<- sample( c(1:length(w)),1)
}

if(AF_num==2)
{
	AF<- apply(cbind(post_var,cost_post_var),1,max) 
	max_af_num<- order(AF,decreasing=T)[1]
	new_x_num<- ceiling(max_af_num/grid_num)
	new_w_num<- max_af_num-(new_x_num-1)*grid_num
}

if(AF_num==3)
{
	new_x_num<- order(cF1_ucb,decreasing=T)[1]
	new_w_num<- order((cost_post_var[(grid_num*(new_x_num-1)+1):(grid_num*new_x_num)]),decreasing=T)[1]
}

if(AF_num==4)
{
	mile<- apply( matrix(c(1:(grid_num*grid_num))),1,compute_MILE) -sum(dist_ptr_lcb>(alpha-accuracy_para))
	fMILE<- apply (matrix(c(1:(grid_num*grid_num))),1,compute_fMILE)-sum(    ((dist_ptr_lcb<alpha)*(dist_ptr_ucb>alpha))%x%(numeric(grid_num)+1)* (lcb   >(h-accuracy_para)))
	mile2<- apply(cbind(mile,fMILE*gamma),1,max)
	max_rmile_num<- order(mile2,decreasing=T)[1]

	new_x_num<- ceiling(max_rmile_num/grid_num)
	new_w_num<- max_rmile_num-(new_x_num-1)*grid_num
}

if(AF_num==5)
{
	sampling_ptr_above_prob<-numeric(grid_num)
	for(x_index in 1:grid_num)
	{
	post_cov_xindex<-prior_cov-kerV[((x_index-1)*grid_num+1):(x_index*grid_num),]%*%invC%*%t(kerV[((x_index-1)*grid_num+1):(x_index*grid_num),])
	post_mean_xindex<- post_mean[((x_index-1)*grid_num+1):(x_index*grid_num)]

	SVD_mat<-t(diag(sqrt(svd(post_cov_xindex)$d))%*%t(svd(post_cov_xindex)$v))
	sampling_f<- t(post_mean_xindex)%x%(numeric(sampling_num)+1)+ t(SVD_mat%*% t(mvrnorm(sampling_num,numeric(grid_num),diag(grid_num))))

	sampling_ptr_above_prob[x_index]<-mean(((sampling_f>=h)%*%ref_p)>=alpha)

	}

	expected_ptr<- colSums(matrix(pnorm((post_mean-h)/sqrt(post_var)),grid_num,grid_num)*ref_p)


	cost_mean_prior_var<- as.vector(t(ref_p)%*%prior_cov_cost%*%ref_p)
	mean_cost_kerV0<- colSums(matrix(compute_cost_kernel(ALLinput[,1],ALLinput[,2],newx,neww),grid_num,grid_num)*ref_p)
	mean_cost_kerV[,www]<-mean_cost_kerV0

	cost_mean_post_mean<- as.vector(as.matrix(mean_cost_kerV[,1:www])%*%cost_invC%*%C_Y2)
	cost_mean_post_var<- abs(cost_mean_prior_var-rowSums((as.matrix(mean_cost_kerV[,1:www])%*%cost_invC)*as.matrix(mean_cost_kerV[,1:www])))


	if(max(expected_ptr)>=alpha)
	{
	z_feas_num<- c(1:grid_num)[expected_ptr>=alpha]
	z_feas_max<-max(cost_mean_post_mean[z_feas_num])
	} else {
		z_feas_num<- order(expected_ptr,decreasing=T)[1]
		z_feas_max<-cost_mean_post_mean[z_feas_num]
	}

	Z_0<- (cost_mean_post_mean-z_feas_max)/sqrt(cost_mean_post_var)
	EI_Z<- sqrt(cost_mean_post_var)*Z_0*pnorm(Z_0)+sqrt(cost_mean_post_var)*stn(Z_0)
	EFI<- EI_Z*sampling_ptr_above_prob

	new_x_num<- order(EFI,decreasing=T)[1]

target_x_num<- new_x_num
target_x<- x[target_x_num]

ABAB<-post_var[((target_x_num-1)*grid_num+1):(target_x_num*grid_num)]
CDCD<-t(t((prior_cov-as.matrix(kerV[((target_x_num-1)*grid_num+1):(target_x_num*grid_num),])%*%invC%*%t(as.matrix(kerV[((target_x_num-1)*grid_num+1):(target_x_num*grid_num),])))^2)*(1/(post_var[((target_x_num-1)*grid_num+1):(target_x_num*grid_num)]+sigman)))
EFEF<- ABAB-CDCD

GHGH<-pnorm((post_mean[((target_x_num-1)*grid_num+1):(target_x_num*grid_num)]-h)/sqrt(abs(EFEF)))
VAR_PTR<-colSums(GHGH*(1-GHGH)*ref_p)


one_step_cost_mean_var<-cost_mean_post_var[target_x_num]-(colSums(prior_cov_cost*ref_p)-as.vector(t(ref_p)%*%as.matrix(cost_kerV[((target_x_num-1)*grid_num+1):(target_x_num*grid_num),])%*%cost_invC%*%t(as.matrix(cost_kerV[((target_x_num-1)*grid_num+1):(target_x_num*grid_num),]))))^2*(1/(cost_post_var[((target_x_num-1)*grid_num+1):(target_x_num*grid_num)]+sigman))
m_one_step_Z_var<-(colSums(prior_cov_cost*ref_p)-as.vector(t(ref_p)%*%as.matrix(cost_kerV[((target_x_num-1)*grid_num+1):(target_x_num*grid_num),])%*%cost_invC%*%t(as.matrix(cost_kerV[((target_x_num-1)*grid_num+1):(target_x_num*grid_num),]))))^2*(1/(cost_post_var[((target_x_num-1)*grid_num+1):(target_x_num*grid_num)]+sigman))

one_step_I_var<- numeric(grid_num)
for(s in 1:grid_num)
{
	sampled_m<- cost_mean_post_mean[target_x_num]+rnorm(sampling_num,0,sqrt(m_one_step_Z_var[s]))
	sampled_EI<- compute_EI(sampled_m,one_step_cost_mean_var[s],z_feas_max)
	one_step_Var<- sampled_EI*(sampled_m-z_feas_max-sampled_EI)+one_step_cost_mean_var[s]*pnorm( (sampled_m-z_feas_max)/sqrt(one_step_cost_mean_var[s])   )
	one_step_I_var[s]<- mean(one_step_Var)+var(sampled_EI)
}




	AF_w<- one_step_I_var*VAR_PTR
	new_w_num<-order(AF_w)[1]
}

if(AF_num==6)
{
	if(max(dist_ptr_lcb)>=alpha)
	{
	upper_num<- c(1:grid_num)[dist_ptr_lcb>=alpha]
	est_c_best<- max(cF1_lcb[upper_num])
	} else {
	upper_num<- c(1:grid_num)[dist_ptr_ucb>=alpha]
	est_c_best<- min(cF1_lcb[upper_num])
	}

	estimated_prob<-apply(cbind(dist_ptr_lcb,dist_ptr_ucb),1,compute_estimated_prob)
	AF<-(cF1_ucb-est_c_best)*estimated_prob

	new_x_num<- order(AF,decreasing=T)[1]
	new_w_num<- order((cost_post_var[(grid_num*(new_x_num-1)+1):(grid_num*new_x_num)]+post_var[(grid_num*(new_x_num-1)+1):(grid_num*new_x_num)]),decreasing=T)[1]
}

if(AF_num==7)
{
	if(max(dist_ptr_lcb)>=alpha)
	{
	upper_num<- c(1:grid_num)[dist_ptr_lcb>=alpha]
	est_c_best<- max(cF1_lcb[upper_num])
	} else {
	upper_num<- c(1:grid_num)[dist_ptr_ucb>=alpha]
	est_c_best<- min(cF1_lcb[upper_num])
	}

	potential_opt_set<-(dist_ptr_ucb>alpha)*(cF1_ucb>max(cF1_lcb[dist_ptr_lcb>alpha]))
	AF<-sqrt((cF1_ucb-cF1_lcb)^2+(dist_ptr_ucb-dist_ptr_lcb)^2)*potential_opt_set

	new_x_num<- order(AF,decreasing=T)[1]
	new_w_num<- order((cost_post_var[(grid_num*(new_x_num-1)+1):(grid_num*new_x_num)]+post_var[(grid_num*(new_x_num-1)+1):(grid_num*new_x_num)]),decreasing=T)[1]

}

################################################################################



newx<-  x[new_x_num]
neww<- w[new_w_num]

newy<- true_function_mat[new_x_num,new_w_num]+rnorm(1,0,sqrt(sigman))
newy2<- cost_function1_mat[new_x_num,new_w_num]+rnorm(1,0,sqrt(cost_sigman))


	}

}


write.table(UG_mat,"UG_mat.txt")






